package com.example

import com.example.jwtbuilder.TokenBuilder
import com.example.model.Login
import org.eclipse.microprofile.openapi.annotations.Operation
import org.eclipse.microprofile.openapi.annotations.responses.APIResponse
import javax.enterprise.context.RequestScoped
import javax.inject.Inject
import javax.json.Json
import javax.json.JsonObject
import javax.ws.rs.Consumes
import javax.ws.rs.POST
import javax.ws.rs.Path
import javax.ws.rs.Produces
import javax.ws.rs.core.MediaType

@Path("/login")
@RequestScoped
@Produces(MediaType.APPLICATION_JSON)
@Consumes(MediaType.APPLICATION_JSON)
class TokenResource {

    @Inject
    protected lateinit var tokenBuilder: TokenBuilder

    @POST
    @Operation(summary = "Update subject")
    @APIResponse(responseCode = "200", description = "User was authenticated")
    fun authenticate(login: Login): JsonObject {

        val token = tokenBuilder.buildToken(login)
        return Json.createObjectBuilder().add("token", token).build()
    }

}