import requests
import json
import time

SUBJECT_URL = "http://subject-service-app-xbily-dev.apps.sandbox-m2.ll9k.p1.openshiftapps.com"
# SUBJECT_URL = "http://localhost:8080"


def print_all_enrollments(token):
    print("\nAll enrollments:")
    json_object = json.loads(get_all_enrollments(token).text)
    print(json.dumps(json_object, indent=2))


def get_all_enrollments(token):
    headers = {"Authorization": "Bearer " + token}
    return requests.get(SUBJECT_URL + '/enrolled-subjects', headers=headers)


def delete_all_enrollments(token):
    start_time = time.time()
    headers = {"Authorization": "Bearer " + token}
    response = requests.delete(SUBJECT_URL + '/enrolled-subjects', headers=headers)
    if response.status_code == 204:
        print("Deleted all enrolled subjects")
    else:
        print("Failed to delete all enrolled subjects: " + response.text)
    print("--- %s seconds ---" % (time.time() - start_time))


def delete_enrollment(id, token):
    start_time = time.time()
    headers = {"Authorization": "Bearer " + token}
    response = requests.delete(SUBJECT_URL + '/enrolled-subjects/' + str(id), headers=headers)
    if response.status_code == 204:
        print("Deleted enrollment with id " + str(id))
    else:
        print("Failed to delete enrollment: " + response.text)
    print("--- %s seconds ---" % (time.time() - start_time))


def create_enrollment(user_id, subject_id, token):
    start_time = time.time()
    json_data = {
      "userId": user_id,
      "subjectId": subject_id,
    }
    headers = {"Authorization": "Bearer " + token}
    response = requests.post(SUBJECT_URL + '/enrolled-subjects', json=json_data, headers=headers)

    if response.status_code == 201:
        print("Successfully created enrollment: userId " + str(user_id) + ", subjectId " + str(subject_id))
    else:
        print("Failed to create enrollment: " + response.text + ".     Reason: " + response.reason)
    print("--- %s seconds ---" % (time.time() - start_time))
