from subject_utils import *
from user_utils import *
from enrollment_utils import *
from auth_utils import *
from threading import Thread


def do_enrollments_using_threads(token):
    start_time = time.time()

    threads = []
    for _ in range(1000):
        for student in all_students:
            t = Thread(target=create_enrollment, args=(student["id"], subject1["id"], token))
            threads.append(t)
    for t in threads:
        t.start()
    for t in threads:
        t.join()

    print("-------- finished creating enrollments using threads: %s seconds --------\n\n" % (
                time.time() - start_time))


def do_enrollments_without_threads(token):
    start_time = time.time()

    for _ in range(3):
        for student in all_students:
            create_enrollment(student["id"], subject1["id"], token)

    print("-------- finished creating enrollments without threads: %s seconds --------\n\n" % (
                time.time() - start_time))


print("\n-------- get tokens --------")
admin_token = get_token("admin", "Administrator", "", "admin@mail.com", ["Admin"])
student_token = get_token("student1", "Franta", "Vomacka", "student@mail.com", ["Student"])


print("\n\n-------- deleting old enrollments --------")
delete_all_enrollments(admin_token)

print("\n\n-------- deleting old users --------")
delete_all_users(admin_token)

print("\n\n-------- deleting old subjects --------")
delete_all_subjects(admin_token)


print("\n\n-------- creating users --------")
create_user("teacher1", "Franta", "Vomacka", "Teacher", "1234", admin_token)

create_user("student1", "Pepa", "Polivka", "Student", "12345", admin_token)
create_user("student2", "Honza", "Knedlik", "Student", "12345", admin_token)
create_user("student3", "Karlik", "Rohlik", "Student", "12345", admin_token)
create_user("student4", "Jenda", "Houska", "Student", "12345", admin_token)

# create_user("admin1", "Admin", "", "Admin", "123456789", admin_token)
# print_all_users(admin_token)


print("\n\n-------- creating subjects --------")
teacher1 = get_user_by_nickname('teacher1', admin_token)
create_subject("PV217", teacher1["id"], 20000, admin_token)
# create_subject("PA220", teacher1["id"], 25000, admin_token)
# print_all_subjects(admin_token)



print("\n\n-------- creating enrollments --------")
subject1 = get_subject_by_name("PV217", admin_token)
all_students = get_all_students(admin_token)

do_enrollments_using_threads(student_token)
# do_enrollments_without_threads(student_token)

# print_all_enrollments()

